;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cells; -*-
#|

    Hunchncells -- Cells, Parenscript, and HTML

Copyright (C) 2008 by Andy Chambers

This library is free software; you can redistribute it and/or
modify it under the terms of the Lisp Lesser GNU Public License
 (http://opensource.franz.com/preamble.html), known as the LLGPL.

This library is distributed  WITHOUT ANY WARRANTY; without even 
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the Lisp Lesser GNU Public License for more details.

|#

(in-package :openair)

(progn
  (declaim (optimize (debug 3) (speed 0) (safety 1) (compilation-speed 0))))

(defmodel web-apropos (page)
  ((term :initarg :term :accessor term :initform nil))
  (:default-initargs
      :term (c? (param? "s"))
    :title "Lisp Apropos"
    :style "style.css"
    :kids (c? (the-kids
	       (mk-div ()
		 (mk-form (:action "post")
		   (mk-label (:for "s")
		     (mk-text "Apropos: "))
		   (mk-input (:name "s" :id "s"
				    :-type "text"
				    :value (c? (reverse (term (u^ web-apropos))))))
		   (mk-div ()
		     (mk-text (c? (reverse (term (u^ web-apropos))))))))))))
;; 		   (mk-div ()
;; 		     :kids (c? (the-kids
;; 				(case (intern (term (u^ web-apropos)))
;; 				  (andy (mk-text "apprentice"))
;; 				  (kenny (mk-text "wizard"))
;; 				  (otherwise (mk-text "unknown"))))))))))))


;; 		       (c? (the-kids
;; 			    (loop for func in (apropos-list (term (u^ web-apropos)))
;; 				collect (mk-li ()
;; 					  (mk-text func)))))))))))))

(defobserver value ((self input))
  (print (list "value: " new-value old-value)))

(defvar *web-app* nil)

(defun test-page (path resource-class)
  (lambda (request)
    (start-session)
    (let ((root (or (session-value 'root)
		   (not (print "creating new web-app..."))
		   (mk-web-app (:prefix path
                                :request (c-in request))
		     (make-instance
		      resource-class
		      :fm-parent *parent*)))))
      (setf *web-app* root)
      (setf (session-value 'root) root)
      (setf (request root) request)
      (handler root))))

(defun test-page-allegro (path resource-class)
  (lambda (req ent)
    (with-http-response (req ent)
      (with-http-body (req ent)
;;	(print "hi" (request-reply-stream req))))))
	(let ((root (or (cdr (assoc "root" (get-cookie-values req)))
			(not (print "creating new web-app..."))
			(mk-web-app (:prefix path
                                     :request (c-in req))
			  (make-instance
			   resource-class
			   :fm-parent *parent*)))))
	  (set-cookie-header req
			     :name "root"
			     :value root)
	  (print (funcall (handler root)) (request-reply-stream req)))))))

(defun reload-allegro ()
  (publish-prefix :prefix "/apropos"
		  :function (test-page-allegro 
			     "/apropos" 
			     'web-apropos)))


(defun reload ()
  (cells-reset)
  (reset-sessions)
  (setf *catch-errors-p* nil
	*dispatch-table* 
	(list 
	 (test-page "/apropos" 'web-apropos)
;; 	 (create-prefix-dispatcher "/apropos"
;; 				   (test-page "/apropos" 'web-apropos))
	 (create-folder-dispatcher-and-handler "/js/"
					       "/Users/andy/hacking/hunchncells/js/"))))


